Subject: [RFC PATCH] iommu: create direct_mapping after device attached

From: [email-masked] (Joerg Roedel)
Date: Wed, 20 Jul 2016 16:01:27 +0200

On Wed, Jul 20, 2016 at 08:49:21PM +0800, honghui.zhang at mediatek.com wrote:
> From: Honghui Zhang <[email-masked]>
> 
> For mtk iommu, the domain_finalize was called in device attatch, the mtk
> iommu iopgt ops was allocated and initialized in domain_finalize, the
> iommu_group_create_direct_mappings would call the map interface to
> implement the map. If it's earlier than device attach, there would be NULL
> dereference. Move the iommu_group_create_direct_mappings call after device
> attached.

No, this would open a race window where the device is attached, but
doesn't have its unity-mappings in place. You should re-organize the mtk
driver instead, so that it works in this order too.

	Joerg